-- CastBar management for WoW classic
 
if select(4, GetBuildInfo())>20000 then return end

local CastInfo = LibStub("LibClassicCastInfo-1.0")
local GuidCastingInfo = CastInfo.GuidCastingInfo
local RegisterCallback = CastInfo.RegisterCallback
local UnregisterCallback = CastInfo.UnregisterCallback

local function RefreshCastBar(self, event, guid)
	if self.guid then
		local spellID, spellName, texture, start, duration, channeling = GuidCastingInfo(self.guid)
		if spellID then
			self.channeling = channeling
			self.maxValue = duration
			self.value    = GetTime() - start
			self:SetMinMaxValues(0, self.maxValue)
			self.Text:SetText(spellName)
			self.Icon:SetTexture(texture)
			self:Show()
			return		
		end
	end
	self:Hide()
end

function KiwiPlatesCastingBarFrame_OnUpdate(self, elapsed)
	local value = self.value + elapsed
	if value<self.maxValue then
		self.value = value
		self:SetValue(self.channeling and self.maxValue-value or value)
	else
		self:Hide()
	end
end

function KiwiPlatesCastingBarFrame_SetUnit(self, unit)
	if unit then
		local guid = UnitGUID(unit)
		if guid and guid ~= self.guid then
			self.guid = guid
			RegisterCallback( guid, self, RefreshCastBar )
			RefreshCastBar(self)
		end	
	else
		if self.guid then
			UnregisterCallback( self.guid, self )
			self.guid = nil
		end
		self:Hide()
	end
end
